<?php
/***************************************************************
*  Copyright notice
*
*  (c) 1999-2008 Kasper Skaarhoj (kasperYYYY@typo3.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * patch
 * Module: Web>Page
 *
 * This module lets you view a page in a more Content Management like style than the ordinary record-list
 *
 * $Id: db_layout.php 6133 2009-10-11 12:32:22Z rupi $
 *
 * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
 * @author	Franz Holzinger <franz@ttproducts.de>
 */




/**
 * Script Class for Web > Layout module
 *
 * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
 * @package TYPO3
 * @subpackage core
 */
class  ux_SC_db_layout extends SC_db_layout {
	var $externalTables;	// Array of tables to be listed by the Web > Page module in addition to the default tables
	var $externalLLFile;	// Array of language XML files to be used for the translated texts
	var $allowPage0;	// Array with table index which are allowed for display on the root page 0

	/**
	 * Initializing the module
	 *
	 * @return	void
	 */
	function init()	{
		global $BE_USER;

			// Setting module configuration / page select clause
		$this->MCONF = $GLOBALS['MCONF'];
		$this->perms_clause = $BE_USER->getPagePermsClause(1);
		$this->backPath = $GLOBALS['BACK_PATH'];

			// GPvars:
		$this->id = intval(t3lib_div::_GP('id'));
		$this->pointer = t3lib_div::_GP('pointer');
		$this->imagemode = t3lib_div::_GP('imagemode');

		$this->clear_cache = t3lib_div::_GP('clear_cache');
		$this->popView = t3lib_div::_GP('popView');
		$this->edit_record = t3lib_div::_GP('edit_record');
		$this->new_unique_uid = t3lib_div::_GP('new_unique_uid');
		$this->search_field = t3lib_div::_GP('search_field');
		$this->search_levels = t3lib_div::_GP('search_levels');
		$this->showLimit = t3lib_div::_GP('showLimit');
		$this->returnUrl = t3lib_div::_GP('returnUrl');
		$this->externalTables = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['cms']['db_layout']['addTables'];
		$this->externalLLFile = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['cms']['db_layout']['LLFile'];
		$this->allowPage0 = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['cms']['db_layout']['page0'];
		if ($this->externalTables == '')	{
			$this->externalTables = array();
		}
		if ($this->externalLLFile == '')	{
			$this->externalLLFile = array();
		}
		if ($this->allowPage0 == '')	{
			$this->allowPage0 = array();
		}

			// Load page info array:
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
			// InitialfetchRecordize menu
		$this->menuConfig();

			// Setting sys language from session var:
 		$this->current_sys_language=intval($this->MOD_SETTINGS['language']);

			// Include scripts: QuickEdit
		if ($this->MOD_SETTINGS['function']==0)	{
			$this->include_once[]=PATH_t3lib.'class.t3lib_tceforms.php';
			$this->include_once[]=PATH_t3lib.'class.t3lib_clipboard.php';
			$this->include_once[]=PATH_t3lib.'class.t3lib_loaddbgroup.php';
			$this->include_once[]=PATH_t3lib.'class.t3lib_transferdata.php';
		}

			// Include scripts: Clear-cache cmd.
		if ($this->clear_cache)	{
			$this->include_once[]=PATH_t3lib.'class.t3lib_tcemain.php';
		}

			// CSH / Descriptions:
		$this->descrTable = '_MOD_'.$this->MCONF['name'];
	}

	/**
	 * Initialize menu array
	 *
	 * @return	void
	 */
	function menuConfig()	{
		global $BE_USER,$LANG,$TYPO3_CONF_VARS;

		$typoVersion = t3lib_div::int_from_ver($GLOBALS['TYPO_VERSION']);

			// MENU-ITEMS:
		$this->MOD_MENU = array(
			'tt_board' => array(
				0 => $LANG->getLL('m_tt_board_0'),
				'expand' => $LANG->getLL('m_tt_board_expand')
			),
			'tt_address' => array(
				0 => $LANG->getLL('m_tt_address_0'),
				1 => $LANG->getLL('m_tt_address_1'),
				2 => $LANG->getLL('m_tt_address_2')
			),
			'tt_links' => array(
				0 => $LANG->getLL('m_default'),
				1 => $LANG->getLL('m_tt_links_1'),
				2 => $LANG->getLL('m_tt_links_2')
			),
			'tt_calender' => array (
				0 => $LANG->getLL('m_default'),
				'date' => $LANG->getLL('m_tt_calender_date'),
				'date_ext' => $LANG->getLL('m_tt_calender_date_ext'),
				'todo' => $LANG->getLL('m_tt_calender_todo'),
				'todo_ext' => $LANG->getLL('m_tt_calender_todo_ext')
			),
			'tt_products' => array (
				0 => $LANG->getLL('m_default'),
				'ext' => $LANG->getLL('m_tt_products_ext')
			),
			'tt_content_showHidden' => '',
			'showPalettes' => '',
			'showDescriptions' => '',
			'disableRTE' => '',
			'function' => array(
				0 => $LANG->getLL('m_function_0'),
				1 => $LANG->getLL('m_function_1'),
				2 => $LANG->getLL('m_function_2'),
				3 => $LANG->getLL('pageInformation')
			),
			'language' => array(
				0 => $LANG->getLL('m_default')
			)
		);

		// example settings:
		// 	$TYPO3_CONF_VARS['EXTCONF']['cms']['db_layout']['addTables']['tt_products'] =
		//		array ('ext' => array(
		//			'MENU' => 'LLL:EXT:tt_products/locallang.php:m_ext',
		//			'fList' =>  'title,price2,category;inStock;weight;tax',
		//			'icon' => TRUE)
		//		);
		if (isset($this->externalTables) && is_array($this->externalTables)) {
			foreach ($this->externalTables as $table => $tableSettings) {
				// delete the default settings from above
				if (is_array($this->MOD_MENU[$table])) {
					unset($this->MOD_MENU[$table]);
				}
				if (isset($tableSettings) && is_array($tableSettings)) {
					if (isset($this->externalLLFile) && is_array($this->externalLLFile) && isset($this->externalLLFile[$table]))	{
						$locallang = $LANG->includeLLFile($this->externalLLFile[$table],FALSE);
					} else {
						$locallang = '';
					}
					foreach ($tableSettings as $key => $settings) {
						if ($key == 'langArray')	{
							continue;
						}
						if ($locallang != '')	{
							// use the recommended getLLL function if possible
							$tmpText = $LANG->getLLL($settings['MENU'],$locallang);
						} else {
							$tmpText = $LANG->sL($settings['MENU']);
						}
						$this->MOD_MENU[$table][$key] = $tmpText;
					}
				}
			}
		}

			 // First, select all pages_language_overlay records on the current page. Each represents a possibility for a language on the page. Add these to language selector.
		$res = $this->exec_languageQuery($this->id);
		while($lrow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
			if ($GLOBALS['BE_USER']->checkLanguageAccess($lrow['uid']))	{
				$this->MOD_MENU['language'][$lrow['uid']]=($lrow['hidden']?'('.$lrow['title'].')':$lrow['title']);
			}
		}

		if ($typoVersion >= 4003000)    {	// TYPO3 4.3.0 or higher

				// Find if there are ANY languages at all (and if not, remove the language option from function menu).
			$count = $GLOBALS['TYPO3_DB']->exec_SELECTcountRows('uid', 'sys_language', ($BE_USER->isAdmin() ? '' : 'hidden=0'));
		} else {
			$field = 'uid';
			$where = ($BE_USER->isAdmin() ? '' : 'hidden=0');
			$resultSet = $GLOBALS['TYPO3_DB']->exec_SELECTquery('COUNT(' . $field . ')', 'sys_language', $where);
			if ($resultSet !== false) {
				list($count) = $GLOBALS['TYPO3_DB']->sql_fetch_row($resultSet);
				$GLOBALS['TYPO3_DB']->sql_free_result($resultSet);
			}
		}
		if (!$count) {
			unset($this->MOD_MENU['function']['2']);
		}

			// page/be_user TSconfig settings and blinding of menu-items
		$this->modSharedTSconfig = t3lib_BEfunc::getModTSconfig($this->id, 'mod.SHARED');
		$this->modTSconfig = t3lib_BEfunc::getModTSconfig($this->id,'mod.'.$this->MCONF['name']);
		if ($this->modTSconfig['properties']['QEisDefault'])	ksort($this->MOD_MENU['function']);
		$this->MOD_MENU['function'] = t3lib_BEfunc::unsetMenuItems($this->modTSconfig['properties'],$this->MOD_MENU['function'],'menu.function');

			// Remove QuickEdit as option if page type is not...
		if (!t3lib_div::inList($TYPO3_CONF_VARS['FE']['content_doktypes'].',6',$this->pageinfo['doktype']))	{
			unset($this->MOD_MENU['function'][0]);
		}

			// Setting alternative default label:
		if (($this->modSharedTSconfig['properties']['defaultLanguageLabel'] || $this->modTSconfig['properties']['defaultLanguageLabel']) && isset($this->MOD_MENU['language'][0]))	{
			$this->MOD_MENU['language'][0] = $this->modTSconfig['properties']['defaultLanguageLabel'] ? $this->modSharedTSconfig['properties']['defaultLanguageLabel'] : $this->modSharedTSconfig['properties']['defaultLanguageLabel'];
		}

			// Clean up settings
		$this->MOD_SETTINGS = t3lib_BEfunc::getModuleData($this->MOD_MENU, t3lib_div::_GP('SET'), $this->MCONF['name']);

			// For all elements to be shown in draft workspaces:
		if ($GLOBALS['BE_USER']->workspace!=0)	{
			$this->MOD_SETTINGS['tt_content_showHidden'] = 1;
		}
	}


	/**
	 * Main function.
	 * Creates some general objects and calls other functions for the main rendering of module content.
	 *
	 * @return	void
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH;

		$typoVersion = t3lib_div::int_from_ver($GLOBALS['TYPO_VERSION']);
		// Access check...
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$access = is_array($this->pageinfo) ? 1 : 0;

		if (($this->id || count($this->allowPage0)) && $access)	{

				// Initialize permission settings:
			$this->CALC_PERMS = $BE_USER->calcPerms($this->pageinfo);
			$this->EDIT_CONTENT = ($this->CALC_PERMS&16) ? 1 : 0;

			if ($typoVersion >= 4002000)    {	// TYPO3 4.2.0 or bigger

					// Start document template object:
				$this->doc = t3lib_div::makeInstance('template');
				$this->doc->backPath = $BACK_PATH;
				$this->doc->setModuleTemplate('templates/db_layout.html');
				$this->doc->docType='xhtml_trans';

					// JavaScript:
				$this->doc->JScode = '<script type="text/javascript" src="'.$BACK_PATH.'../t3lib/jsfunc.updateform.js"></script>';
				$this->doc->JScode.= $this->doc->wrapScriptTags('
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
					if (top.fsMod) top.fsMod.navFrameHighlightedID["web"] = "pages'.intval($this->id).'_"+top.fsMod.currentBank; '.intval($this->id).';
					function jumpToUrl(URL,formEl)	{	//
						if (document.editform && TBE_EDITOR.isFormChanged)	{	// Check if the function exists... (works in all browsers?)
							if (!TBE_EDITOR.isFormChanged())	{	//
								window.location.href = URL;
							} else if (formEl) {
								if (formEl.type=="checkbox") formEl.checked = formEl.checked ? 0 : 1;
							}
						} else window.location.href = URL;
					}
				'.($this->popView ? t3lib_BEfunc::viewOnClick($this->id,$BACK_PATH,t3lib_BEfunc::BEgetRootLine($this->id)) : '').'

					function deleteRecord(table,id,url)	{	//
						if (confirm('.$LANG->JScharCode($LANG->getLL('deleteWarning')).'))	{
							window.location.href = "'.$BACK_PATH.'tce_db.php?cmd["+table+"]["+id+"][delete]=1&redirect="+escape(url)+"&vC='.$BE_USER->veriCode().'&prErr=1&uPT=1";
						}
						return false;
					}
				');
				$this->doc->JScode.= $this->doc->wrapScriptTags('
					var DTM_array = new Array();
					var DTM_origClass = new String();

						// if tabs are used in a popup window the array might not exists
					if(!top.DTM_currentTabs) {
						top.DTM_currentTabs = new Array();
					}

					function DTM_activate(idBase,index,doToogle)	{	//
							// Hiding all:
						if (DTM_array[idBase])	{
							for(cnt = 0; cnt < DTM_array[idBase].length ; cnt++)	{
								if (DTM_array[idBase][cnt] != idBase+"-"+index)	{
									document.getElementById(DTM_array[idBase][cnt]+"-DIV").style.display = "none";
									document.getElementById(DTM_array[idBase][cnt]+"-MENU").attributes.getNamedItem("class").nodeValue = "tab";
								}
							}
						}

							// Showing one:
						if (document.getElementById(idBase+"-"+index+"-DIV"))	{
							if (doToogle && document.getElementById(idBase+"-"+index+"-DIV").style.display == "block")	{
								document.getElementById(idBase+"-"+index+"-DIV").style.display = "none";
								if(DTM_origClass=="") {
									document.getElementById(idBase+"-"+index+"-MENU").attributes.getNamedItem("class").nodeValue = "tab";
								} else {
									DTM_origClass = "tab";
								}
								top.DTM_currentTabs[idBase] = -1;
							} else {
								document.getElementById(idBase+"-"+index+"-DIV").style.display = "block";
								if(DTM_origClass=="") {
									document.getElementById(idBase+"-"+index+"-MENU").attributes.getNamedItem("class").nodeValue = "tabact";
								} else {
									DTM_origClass = "tabact";
								}
								top.DTM_currentTabs[idBase] = index;
							}
						}
					}
					function DTM_toggle(idBase,index,isInit)	{	//
							// Showing one:
						if (document.getElementById(idBase+"-"+index+"-DIV"))	{
							if (document.getElementById(idBase+"-"+index+"-DIV").style.display == "block")	{
								document.getElementById(idBase+"-"+index+"-DIV").style.display = "none";
								if(isInit) {
									document.getElementById(idBase+"-"+index+"-MENU").attributes.getNamedItem("class").nodeValue = "tab";
								} else {
									DTM_origClass = "tab";
								}
								top.DTM_currentTabs[idBase+"-"+index] = 0;
							} else {
								document.getElementById(idBase+"-"+index+"-DIV").style.display = "block";
								if(isInit) {
									document.getElementById(idBase+"-"+index+"-MENU").attributes.getNamedItem("class").nodeValue = "tabact";
								} else {
									DTM_origClass = "tabact";
								}
								top.DTM_currentTabs[idBase+"-"+index] = 1;
							}
						}
					}

					function DTM_mouseOver(obj) {	//
							DTM_origClass = obj.attributes.getNamedItem(\'class\').nodeValue;
							obj.attributes.getNamedItem(\'class\').nodeValue += "_over";
					}

					function DTM_mouseOut(obj) {	//
							obj.attributes.getNamedItem(\'class\').nodeValue = DTM_origClass;
							DTM_origClass = "";
					}
				');

					// Setting doc-header
				$this->doc->form='<form action="'.htmlspecialchars('db_layout.php?id='.$this->id.'&imagemode='.$this->imagemode).'" method="post">';

					// Creating the top function menu:
				$this->topFuncMenu = t3lib_BEfunc::getFuncMenu($this->id,'SET[function]',$this->MOD_SETTINGS['function'],$this->MOD_MENU['function'],'db_layout.php','');
				$this->languageMenu = (count($this->MOD_MENU['language'])>1 ? $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_general.xml:LGL.language',1) . t3lib_BEfunc::getFuncMenu($this->id,'SET[language]',$this->current_sys_language,$this->MOD_MENU['language'],'db_layout.php','') : '');

					// Find columns
				$modTSconfig_SHARED = t3lib_BEfunc::getModTSconfig($this->id,'mod.SHARED');		// SHARED page-TSconfig settings.
				$this->colPosList = strcmp(trim($this->modTSconfig['properties']['tt_content.']['colPos_list']),'') ? trim($this->modTSconfig['properties']['tt_content.']['colPos_list']) : $modTSconfig_SHARED['properties']['colPos_list'];
				$this->colPosList = strcmp($this->colPosList,'')?$this->colPosList:'1,0,2,3';
				$this->colPosList = implode(',',array_unique(t3lib_div::intExplode(',',$this->colPosList)));		// Removing duplicates, if any


					// Render the primary module content:
				if ($this->MOD_SETTINGS['function']==0)	{
					$body = $this->renderQuickEdit();	// QuickEdit
				} else {
					$body = $this->renderListContent();	// All other listings
				}

					// Setting up the buttons and markers for docheader
				$docHeaderButtons = $this->getButtons($this->MOD_SETTINGS['function']==0 ? 'quickEdit' : '');
				$markers = array(
					'CSH' => $docHeaderButtons['csh'],
					'TOP_FUNCTION_MENU' => $this->editSelect . $this->topFuncMenu,
					'LANGSELECTOR' => $this->languageMenu,
					'CONTENT' => $body
				);

					// Build the <body> for the module
				$this->content = $this->doc->startPage($LANG->getLL('title'));
				$this->content.= $this->doc->moduleBody($this->pageinfo, $docHeaderButtons, $markers);
				$this->content.= $this->doc->endPage();
				$this->content = $this->doc->insertStylesAndJS($this->content);
			} else {
					// Start document template object:
				$this->doc = t3lib_div::makeInstance('mediumDoc');
				$this->doc->backPath = $BACK_PATH;
				$this->doc->docType='xhtml_trans';

					// JavaScript:
				$this->doc->JScode = '<script type="text/javascript" src="'.$BACK_PATH.'../t3lib/jsfunc.updateform.js"></script>';
				$this->doc->JScode.= $this->doc->wrapScriptTags('
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
					if (top.fsMod) top.fsMod.navFrameHighlightedID["web"] = "pages'.intval($this->id).'_"+top.fsMod.currentBank; '.intval($this->id).';
					function jumpToUrl(URL,formEl)	{	//
						if (document.editform && TBE_EDITOR.isFormChanged)	{	// Check if the function exists... (works in all browsers?)
							if (!TBE_EDITOR.isFormChanged())	{	//
								window.location.href = URL;
							} else if (formEl) {
								if (formEl.type=="checkbox") formEl.checked = formEl.checked ? 0 : 1;
							}
						} else window.location.href = URL;
					}
				'.($this->popView ? t3lib_BEfunc::viewOnClick($this->id,$BACK_PATH,t3lib_BEfunc::BEgetRootLine($this->id)) : '').'

					function deleteRecord(table,id,url)	{	//
						if (confirm('.$LANG->JScharCode($LANG->getLL('deleteWarning')).'))	{
							window.location.href = "'.$BACK_PATH.'tce_db.php?cmd["+table+"]["+id+"][delete]=1&redirect="+escape(url)+"&vC='.$BE_USER->veriCode().'&prErr=1&uPT=1";
						}
						return false;
					}
				');

					// Setting doc-header
				$this->doc->form='<form action="'.htmlspecialchars('db_layout.php?id='.$this->id.'&imagemode='.$this->imagemode).'" method="post">';

					// Creating the top function menu:
				$this->topFuncMenu = t3lib_BEfunc::getFuncMenu($this->id,'SET[function]',$this->MOD_SETTINGS['function'],$this->MOD_MENU['function'],'db_layout.php','').
							(count($this->MOD_MENU['language'])>1 ? '<br />'.t3lib_BEfunc::getFuncMenu($this->id,'SET[language]',$this->current_sys_language,$this->MOD_MENU['language'],'db_layout.php','') : '');

					// Creating the top edit page icon:
				if ($this->CALC_PERMS&2)	{
					$params='&edit[pages]['.$this->id.']=edit';
					$this->editIcon='<a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick($params,$BACK_PATH)).'"><img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/edit2.gif','width="11" height="12"').' vspace="2" align="top" title="'.$LANG->getLL('editPageProperties',1).'" alt="" /></a>';
				} else {
					$this->editIcon='';
				}

					// Find columns
				$modTSconfig_SHARED = t3lib_BEfunc::getModTSconfig($this->id,'mod.SHARED');		// SHARED page-TSconfig settings.
				$this->colPosList = strcmp(trim($this->modTSconfig['properties']['tt_content.']['colPos_list']),'') ? trim($this->modTSconfig['properties']['tt_content.']['colPos_list']) : $modTSconfig_SHARED['properties']['colPos_list'];
				$this->colPosList = strcmp($this->colPosList,'')?$this->colPosList:'1,0,2,3';
				$this->colPosList = implode(',',array_unique(t3lib_div::intExplode(',',$this->colPosList)));		// Removing duplicates, if any


					// Render the primary module content:
				if ($this->MOD_SETTINGS['function']==0)	{
					$this->renderQuickEdit();	// QuickEdit
				} else {
					$this->renderListContent();	// All other listings
				}


					// ShortCut
				if ($BE_USER->mayMakeShortcut())	{
					$this->content.=$this->doc->spacer(20).$this->doc->section('',$this->doc->makeShortcutIcon('id,edit_record,pointer,new_unique_uid,search_field,search_levels,showLimit',implode(',',array_keys($this->MOD_MENU)),$this->MCONF['name']));
				}

					// Ending page:
				$this->content.=$this->doc->spacer(10);
				$this->content.=$this->doc->endPage();
			}
		} else {

			if ($typoVersion >= 4002000)    {	// TYPO3 4.2.0 or bigger

					// If no access or id value, create empty document:
				$this->doc = t3lib_div::makeInstance('template');
				$this->doc->docType='xhtml_trans';
				$this->doc->backPath = $BACK_PATH;
				$this->doc->setModuleTemplate('templates/db_layout.html');

				$this->doc->JScode = $this->doc->wrapScriptTags('
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				');

				$body = $this->doc->section($LANG->getLL('clickAPage_header'), $LANG->getLL('clickAPage_content'), 0, 1);

					// Setting up the buttons and markers for docheader
				$docHeaderButtons = array(
					'view' => '',
					'history_page' => '',
					'new_content' => '',
					'move_page' => '',
					'move_record' => '',
					'new_page' => '',
					'edit_page' => '',
					'record_list' => '',
					'csh' => '',
					'shortcut' => '',
					'cache' => '',
					'savedok' => '',
					'savedokshow' => '',
					'closedok' => '',
					'deletedok' => '',
					'undo' => '',
					'history_record' => ''
				);

				$markers = array(
					'CSH' => t3lib_BEfunc::cshItem($this->descrTable, '', $BACK_PATH, '', TRUE),
					'TOP_FUNCTION_MENU' => '',
					'LANGSELECTOR' => '',
					'CONTENT' => $body
				);

				$this->content=$this->doc->startPage($LANG->getLL('title'));
				$this->content.= $this->doc->moduleBody($this->pageinfo, $docHeaderButtons, $markers);
				$this->content.=$this->doc->endPage();
				$this->content = $this->doc->insertStylesAndJS($this->content);
			} else {
					// If no access or id value, create empty document:
				$this->doc = t3lib_div::makeInstance('mediumDoc');
				$this->doc->docType='xhtml_trans';
				$this->doc->backPath = $BACK_PATH;
				$this->doc->JScode = $this->doc->wrapScriptTags('
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				');
				$this->content=$this->doc->startPage($LANG->getLL('title'));
				$this->content.=$this->doc->section($LANG->getLL('clickAPage_header'),$LANG->getLL('clickAPage_content'),0,1);

				$this->content.= t3lib_BEfunc::cshItem($this->descrTable,'',$BACK_PATH,'<br/><br/>');

				$this->content.=$this->doc->endPage();
			}
		}
	}


	/**
	 * Rendering all other listings than QuickEdit
	 *
	 * @return	void
	 */
	function renderListContent()	{
		global $LANG,$BACK_PATH,$TCA;

		$typoVersion = t3lib_div::int_from_ver($GLOBALS['TYPO_VERSION']);

			// Initialize list object (see "class.db_layout.inc"):
		$dblist = t3lib_div::makeInstance('tx_cms_layout');
		$dblist->backPath = $BACK_PATH;
		$dblist->thumbs = $this->imagemode;
		$dblist->no_noWrap = 1;
		$dblist->descrTable = $this->descrTable;

		$this->pointer = t3lib_div::intInRange($this->pointer,0,100000);
		$dblist->script = 'db_layout.php';
		$dblist->showIcon = 0;
		$dblist->setLMargin=0;
		$dblist->doEdit = $this->EDIT_CONTENT;
		$dblist->ext_CALC_PERMS = $this->CALC_PERMS;

		$dblist->agePrefixes = $LANG->sL('LLL:EXT:lang/locallang_core.php:labels.minutesHoursDaysYears');
		$dblist->id = $this->id;
		$dblist->nextThree = t3lib_div::intInRange($this->modTSconfig['properties']['editFieldsAtATime'],0,10);
		$dblist->option_showBigButtons = $this->modTSconfig['properties']['disableBigButtons'] ? 0 : 1;
		$dblist->option_newWizard = $this->modTSconfig['properties']['disableNewContentElementWizard'] ? 0 : 1;
		$dblist->defLangBinding = $this->modTSconfig['properties']['defLangBinding'] ? 1 : 0;
		if (!$dblist->nextThree)	$dblist->nextThree = 1;

		$dblist->externalTables = $this->externalTables;
		$dblist->translateTools = t3lib_div::makeInstance('t3lib_transl8tools');


			// Create menu for selecting a table to jump to (this is, if more than just pages/tt_content elements are found on the page!)
		$h_menu = $dblist->getTableMenu($this->id);

			// Initialize other variables:
		$h_func='';
		$tableOutput=array();
		$tableJSOutput=array();
		$CMcounter = 0;

			// Traverse the list of table names which has records on this page (that array is populated by the $dblist object during the function getTableMenu()):
		reset($dblist->activeTables);
		while(list($table)=each($dblist->activeTables))	{

			if (!$this->id && !$this->allowPage0[$table])	{
				continue;
			}

				// Load full table definitions:
			t3lib_div::loadTCA($table);

			if (!isset($dblist->externalTables[$table]))	{
					// Creating special conditions for each table:
				switch($table)	{
					case 'tt_board':
						$h_func = t3lib_BEfunc::getFuncMenu($this->id,'SET[tt_board]',$this->MOD_SETTINGS['tt_board'],$this->MOD_MENU['tt_board'],'db_layout.php','');
					break;
					case 'tt_address':
						$h_func = t3lib_BEfunc::getFuncMenu($this->id,'SET[tt_address]',$this->MOD_SETTINGS['tt_address'],$this->MOD_MENU['tt_address'],'db_layout.php','');
					break;
					case 'tt_links':
						$h_func = t3lib_BEfunc::getFuncMenu($this->id,'SET[tt_links]',$this->MOD_SETTINGS['tt_links'],$this->MOD_MENU['tt_links'],'db_layout.php','');
					break;
					case 'tt_calender':
						$h_func = t3lib_BEfunc::getFuncMenu($this->id,'SET[tt_calender]',$this->MOD_SETTINGS['tt_calender'],$this->MOD_MENU['tt_calender'],'db_layout.php','');
					break;
					case 'tt_products':
						$h_func = t3lib_BEfunc::getFuncMenu($this->id,'SET[tt_products]',$this->MOD_SETTINGS['tt_products'],$this->MOD_MENU['tt_products'],'db_layout.php','');
					break;
					case 'tt_guest':
					case 'tt_news':
					case 'fe_users':
						// Nothing
					break;
					case 'tt_content':
						$q_count = $this->getNumberOfHiddenElements();
						$h_func_b= t3lib_BEfunc::getFuncCheck($this->id,'SET[tt_content_showHidden]',$this->MOD_SETTINGS['tt_content_showHidden'],'db_layout.php','','id="checkTt_content_showHidden"').'<label for="checkTt_content_showHidden">'.(!$q_count?$GLOBALS['TBE_TEMPLATE']->dfw($LANG->getLL('hiddenCE')):$LANG->getLL('hiddenCE').' ('.$q_count.')').'</label>';

						$dblist->tt_contentConfig['showCommands'] = 1;	// Boolean: Display up/down arrows and edit icons for tt_content records
						$dblist->tt_contentConfig['showInfo'] = 1;		// Boolean: Display info-marks or not
						$dblist->tt_contentConfig['single'] = 0; 		// Boolean: If set, the content of column(s) $this->tt_contentConfig['showSingleCol'] is shown in the total width of the page

							// Setting up the tt_content columns to show:
						if (is_array($TCA['tt_content']['columns']['colPos']['config']['items']))	{
							$colList = array();
							foreach($TCA['tt_content']['columns']['colPos']['config']['items'] as $temp)	{
								$colList[] = $temp[1];
							}
						} else {	// ... should be impossible that colPos has no array. But this is the fallback should it make any sense:
							$colList = array('1','0','2','3');
						}
						if (strcmp($this->colPosList,''))	{
							$colList = array_intersect(t3lib_div::intExplode(',',$this->colPosList),$colList);
						}

							// If only one column found, display the single-column view.
						if (count($colList)==1)	{
							$dblist->tt_contentConfig['single'] = 1;	// Boolean: If set, the content of column(s) $this->tt_contentConfig['showSingleCol'] is shown in the total width of the page
							$dblist->tt_contentConfig['showSingleCol'] = current($colList);	// The column(s) to show if single mode (under each other)
						}
						$dblist->tt_contentConfig['cols'] = implode(',',$colList);		// The order of the rows: Default is left(1), Normal(0), right(2), margin(3)
						$dblist->tt_contentConfig['showHidden'] = $this->MOD_SETTINGS['tt_content_showHidden'];
						$dblist->tt_contentConfig['sys_language_uid'] = intval($this->current_sys_language);

							// If the function menu is set to "Language":
						if ($this->MOD_SETTINGS['function']==2)	{
							$dblist->tt_contentConfig['single'] = 0;
							$dblist->tt_contentConfig['languageMode'] = 1;
							$dblist->tt_contentConfig['languageCols'] = $this->MOD_MENU['language'];
							$dblist->tt_contentConfig['languageColsPointer'] = $this->current_sys_language;
						}
					break;
				}
 			} else {
				if (isset($this->MOD_SETTINGS) && isset($this->MOD_MENU)) {
					$h_func = t3lib_BEfunc::getFuncMenu($this->id,'SET['.$table.']',$this->MOD_SETTINGS[$table],$this->MOD_MENU[$table],'db_layout.php','');
				} else {
					$h_func = '';
				}
 			}

				// Start the dblist object:
			$dblist->itemsLimitSingleTable = 1000;
			$dblist->start($this->id,$table,$this->pointer,$this->search_field,$this->search_levels,$this->showLimit);
			$dblist->counter = $CMcounter;
			$dblist->ext_function = $this->MOD_SETTINGS['function'];

				// Render versioning selector:
			$dblist->HTMLcode.= $this->doc->getVersionSelector($this->id);

				// Generate the list of elements here:
			$dblist->generateList();

				// Adding the list content to the tableOutput variable:
			$tableOutput[$table]=
							($h_func?$h_func.'<br /><img src="clear.gif" width="1" height="4" alt="" /><br />':'').
							$dblist->HTMLcode.
							($h_func_b?'<img src="clear.gif" width="1" height="10" alt="" /><br />'.$h_func_b:'');

				// ... and any accumulated JavaScript goes the same way!
			$tableJSOutput[$table] = $dblist->JScode;

				// Increase global counter:
			$CMcounter+= $dblist->counter;

				// Reset variables after operation:
			$dblist->HTMLcode='';
			$dblist->JScode='';
			$h_func = '';
			$h_func_b = '';
		}	// END: traverse tables

		if ($typoVersion >= 4002000)    {	// TYPO3 4.2.0 or bigger


				// For Context Sensitive Menus:
			$this->doc->getContextMenuCode();

				// Now, create listing based on which element is selected in the function menu:

			if ($this->MOD_SETTINGS['function']==3) {

					// Making page info:
				$content.=$this->doc->spacer(10);
				$content.=$this->doc->section($LANG->getLL('pageInformation'),$dblist->getPageInfoBox($this->pageinfo,$this->CALC_PERMS&2),0,1);
			} else {

					// Add the content for each table we have rendered (traversing $tableOutput variable)
				foreach($tableOutput as $table => $output)	{
					$content.=$this->doc->section('<a name="'.$table.'"></a>'.$dblist->activeTables[$table],$output,TRUE,TRUE,0,TRUE);
					$content.=$this->doc->spacer(15);
					$content.=$this->doc->sectionEnd();
				}

					// Making search form:
				if (!$this->modTSconfig['properties']['disableSearchBox'] && count($tableOutput))	{
					$content.=$this->doc->section($LANG->sL('LLL:EXT:lang/locallang_core.php:labels.search'),$dblist->getSearchBox(),0,1);
				}

					// Making display of Sys-notes (from extension "sys_note")
				$dblist->id=$this->id;
				$sysNotes = $dblist->showSysNotesForPage();
				if ($sysNotes)	{
					$content.=$this->doc->spacer(10);
					$content.=$this->doc->section($LANG->getLL('internalNotes'),$sysNotes,0,1);
				}

					// Add spacer in bottom of page:
				$content.=$this->doc->spacer(10);
			}

				// Ending page:
			$content.=$this->doc->spacer(10);

			return $content;
		} else {
				// For Context Sensitive Menus:
			$CMparts = $this->doc->getContextMenuCode();
			$this->doc->bodyTagAdditions = $CMparts[1];
			$this->doc->JScode.= $CMparts[0];
			$this->doc->postCode.= $CMparts[2];


				// Draw the page properties.
			$headerSection = $this->doc->getHeader('pages',$this->pageinfo,$this->pageinfo['_thePath'],$this->modTSconfig['properties']['disableIconToolbar']?1:0).'<br />'.
							$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.path',1).': '.
							'<span title="'.htmlspecialchars($this->pageinfo['_thePathFull']).'">'.htmlspecialchars(t3lib_div::fixed_lgd_cs($this->pageinfo['_thePath'],-50)).'</span>';

			if (!$this->modTSconfig['properties']['disableIconToolbar'])	{
					// Create icon "toolbar" for common operations like creating/moving elements/pages etc.
				$toolBar='';
					// History:
				$toolBar.='<a href="#" onclick="'.htmlspecialchars('jumpToUrl(\''.$BACK_PATH.'show_rechis.php?element='.rawurlencode('pages:'.$this->id).'&returnUrl='.rawurlencode(t3lib_div::getIndpEnv('REQUEST_URI')).'#latest\');return false;').'">'.
							'<img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/history2.gif','width="13" height="12"').' vspace="2" hspace="2" align="top" title="'.$LANG->getLL('recordHistory',1).'" alt="" />'.
							'</a>';
					// New content element
				$toolBar.='<a href="'.htmlspecialchars('db_new_content_el.php?id='.$this->id.'&sys_language_uid='.$this->current_sys_language.'&returnUrl='.rawurlencode(t3lib_div::getIndpEnv('REQUEST_URI'))).'">'.
							'<img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/new_record.gif','width="16" height="12"').' vspace="2" hspace="1" align="top" title="'.$LANG->getLL('newContentElement',1).'" alt="" />'.
							'</a>';
					// Move page:
				$toolBar.='<a href="'.htmlspecialchars($BACK_PATH.'move_el.php?table=pages&uid='.$this->id.'&returnUrl='.rawurlencode(t3lib_div::getIndpEnv('REQUEST_URI'))).'">'.
							'<img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/move_page.gif','width="11" height="12"').' vspace="2" hspace="2" align="top" title="'.$LANG->getLL('move_page',1).'" alt="" />'.
							'</a>';
					// Create new page (wizard):
				$toolBar.='<a href="#" onclick="'.htmlspecialchars('jumpToUrl(\''.$BACK_PATH.'db_new.php?id='.$this->id.'&pagesOnly=1&returnUrl='.rawurlencode(t3lib_div::getIndpEnv('REQUEST_URI')).'\');return false;').'">'.
							'<img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/new_page.gif','width="13" height="12"').' hspace="0" vspace="2" align="top" title="'.$LANG->getLL('newPage',1).'" alt="" />'.
							'</a>';
					// Edit page properties:
				$params='&edit[pages]['.$this->id.']=edit';
				$toolBar.='<a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick($params,$BACK_PATH)).'">'.
							'<img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/edit2.gif','width="11" height="12"').' hspace="2" vspace="2" align="top" title="'.$LANG->getLL('editPageProperties',1).'" alt="" />'.
							'</a>';

					// Add CSH (Context Sensitive Help) icon to tool bar:
				$toolBar.= t3lib_BEfunc::cshItem($this->descrTable,'columns_'.$this->MOD_SETTINGS['function'],$BACK_PATH,'',FALSE,'margin-top: 0px; margin-bottom: 0px;');

					// Wrap the toolbar into a table:
				$headerSection.='
					<table border="0" cellpadding="0" cellspacing="0" class="bgColor4">
						<tr>
							<td>'.$toolBar.'</td>
						</tr>
					</table>';
			}

				// Create menu of table-icons for jumping to table-listing anchor points:
			if ($this->MOD_SETTINGS['function']!=3 && count($tableOutput)>1)	{
				$goToTable_menu = '<td valign="top" width="1%" nowrap="nowrap">'.$h_menu.'</td>';
			} else {
				$goToTable_menu = '';
			}

				// Compile the whole header section into a table: Toolbar, Table selector, Function menu(s), Page-edit icon:
			$hS2='
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<td valign="top" width="99%">'.$headerSection.'</td>
						'.$goToTable_menu.'
						<td valign="top" width="1%">'.$this->topFuncMenu.'</td>
						<td valign="top" align="right" width="1%"><img src="clear.gif" width="1" height="3" alt="" /><br />'.$this->editIcon.'</td>
					</tr>
				</table>';

				// Create page properties:
			$this->content.=$this->doc->startPage($LANG->getLL('title'));
			$this->content.=$this->doc->section('',$hS2);


				// Now, create listing based on which element is selected in the function menu:

			if ($this->MOD_SETTINGS['function']==3) {

					// Making page info:
				$this->content.=$this->doc->spacer(10);
				$this->content.=$this->doc->section($LANG->getLL('pageInformation'),$dblist->getPageInfoBox($this->pageinfo,$this->CALC_PERMS&2),0,1);
			} else {

					// Add the content for each table we have rendered (traversing $tableOutput variable)
				foreach($tableOutput as $table => $output)	{
					$this->content.=$this->doc->section('<a name="'.$table.'"></a>'.$dblist->activeTables[$table],$output,TRUE,TRUE,0,TRUE);
					$this->content.=$this->doc->spacer(15);
					$this->content.=$this->doc->sectionEnd();
				}

					// Making search form:
				if (!$this->modTSconfig['properties']['disableSearchBox'] && count($tableOutput))	{
					$this->content.=$this->doc->section($LANG->sL('LLL:EXT:lang/locallang_core.php:labels.search'),$dblist->getSearchBox(),0,1);
				}

					// Making display of Sys-notes (from extension "sys_note")
				$dblist->id=$this->id;
				$sysNotes = $dblist->showSysNotesForPage();
				if ($sysNotes)	{
					$this->content.=$this->doc->spacer(10);
					$this->content.=$this->doc->section($LANG->getLL('internalNotes'),$sysNotes,0,1);
				}

					// Display advanced options: Clear cache, new record link etc:
				if (!$this->modTSconfig['properties']['disableAdvanced'])	{

						// Clear cache links:
					$af_content = $this->doc->clearCacheMenu($this->id);

						// "Create new record" link:
					if (!$this->modTSconfig['properties']['noCreateRecordsLink']) {
						$af_content.='

						<!--
							Link for creating a new record:
						-->
						<div id="typo3-newRecordLink">
								<a href="'.htmlspecialchars($BACK_PATH.'db_new.php?id='.$this->id.'&returnUrl='.rawurlencode(t3lib_div::getIndpEnv('REQUEST_URI'))).'">'.
							'<img'.t3lib_iconWorks::skinImg($BACK_PATH,'gfx/new_el.gif','width="11" height="12"').' alt="" />'.
							$LANG->getLL('newRecordGeneral',1).
							'</a>
						</div>';
					}

						// Add content of the advanced-options section:
					$this->content.=$this->doc->spacer(10);
					$this->content.=$this->doc->section($LANG->getLL('advancedFunctions'),$af_content,0,1);
				}

					// Add spacer in bottom of page:
				$this->content.=$this->doc->spacer(10);
			}
		}
	}
}

// Include extension?
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/patch1822/xclass/user_db_layout.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/patch1822/xclass/user_db_layout.php']);
}


?>
